﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace FireBirdsExtends
{
    public class GUI
    {
        public Texture2D texFrame;
        public Texture2D texNumber;
        public Texture2D texLive;

        public Rectangle recFramePosition0AndDimension;

        public Rectangle recNumber0PositionAndDimension;
        public Rectangle recNumber0CutPosition;

        public Rectangle recNumber1PositionAndDimension;
        public Rectangle recNumber1CutPosition;

        public Rectangle recNumber2PositionAndDimension;
        public Rectangle recNumber2CutPosition;

        public Rectangle recLive0PositionAndDimension;
        public Rectangle recLive0CutPositionAndDimension;

        public Rectangle recLive1PositionAndDimension;
        public Rectangle recLive1CutPositionAndDimension;

        public Rectangle recLive2PositionAndDimension;
        public Rectangle recLive2CutPositionAndDimension;

        public int LiveCount = 3;

        int PositionNumber1 = 0;
        int PositionNumber2 = 0;
        int PositionNumber3 = 0;

        public void LoadContent(ContentManager Content, GraphicsDevice graphics)
        {
            texFrame = Content.Load<Texture2D>("Graphics\\gui_frame");
            texNumber = Content.Load<Texture2D>("Graphics\\gui_number");
            texLive = Content.Load<Texture2D>("Graphics\\gui_lives");

            recFramePosition0AndDimension.X = 0;
            recFramePosition0AndDimension.Y = graphics.Viewport.Height-texFrame.Height;
            recFramePosition0AndDimension.Width = texFrame.Width;
            recFramePosition0AndDimension.Height = texFrame.Height;

            recNumber0PositionAndDimension.X = graphics.Viewport.Width   - texNumber.Width / 10 *2;
            recNumber0PositionAndDimension.Y = graphics.Viewport.Height  - texNumber.Height - 8;
            recNumber0PositionAndDimension.Width = texNumber.Width / 10;
            recNumber0PositionAndDimension.Height = texNumber.Height;

            recNumber0CutPosition.X = 0;
            recNumber0CutPosition.Y = 0;
            recNumber0CutPosition.Width = texNumber.Width / 10;
            recNumber0CutPosition.Height = texNumber.Height;

            recNumber1PositionAndDimension.X = graphics.Viewport.Width - texNumber.Width / 10 * 3;
            recNumber1PositionAndDimension.Y = graphics.Viewport.Height - texNumber.Height - 8;
            recNumber1PositionAndDimension.Width = texNumber.Width / 10;
            recNumber1PositionAndDimension.Height = texNumber.Height;

            recNumber1CutPosition.X = 0;
            recNumber1CutPosition.Y = 0;
            recNumber1CutPosition.Width = texNumber.Width / 10;
            recNumber1CutPosition.Height = texNumber.Height;

            recNumber2PositionAndDimension.X = graphics.Viewport.Width - texNumber.Width / 10 * 4;
            recNumber2PositionAndDimension.Y = graphics.Viewport.Height - texNumber.Height - 8;
            recNumber2PositionAndDimension.Width = texNumber.Width / 10;
            recNumber2PositionAndDimension.Height = texNumber.Height;

            recNumber2CutPosition.X = 0;
            recNumber2CutPosition.Y = 0;
            recNumber2CutPosition.Width = texNumber.Width / 10;
            recNumber2CutPosition.Height = texNumber.Height;

            recLive0PositionAndDimension.X = texLive.Width / 10 * 0;
            recLive0PositionAndDimension.Y = graphics.Viewport.Height - texLive.Height - 8;
            recLive0PositionAndDimension.Height = texLive.Height;
            recLive0PositionAndDimension.Width = texLive.Width/2;

            recLive0CutPositionAndDimension.X = 0;
            recLive0CutPositionAndDimension.Y = 0;
            recLive0CutPositionAndDimension.Height = texLive.Height;
            recLive0CutPositionAndDimension.Width = texLive.Width/2;


            recLive1PositionAndDimension.X = texLive.Width / 10 * 5;
            recLive1PositionAndDimension.Y = graphics.Viewport.Height - texLive.Height - 8;
            recLive1PositionAndDimension.Height = texLive.Height;
            recLive1PositionAndDimension.Width = texLive.Width / 2;


            recLive1CutPositionAndDimension.X = 0;
            recLive1CutPositionAndDimension.Y = 0;
            recLive1CutPositionAndDimension.Height = texLive.Height;
            recLive1CutPositionAndDimension.Width = texLive.Width / 2;

            recLive2PositionAndDimension.X = texLive.Width / 10 * 10;
            recLive2PositionAndDimension.Y = graphics.Viewport.Height - texLive.Height - 8;
            recLive2PositionAndDimension.Height = texLive.Height;
            recLive2PositionAndDimension.Width = texLive.Width / 2;

            recLive2CutPositionAndDimension.X = 0;
            recLive2CutPositionAndDimension.Y = 0;
            recLive2CutPositionAndDimension.Height = texLive.Height;
            recLive2CutPositionAndDimension.Width = texLive.Width / 2;
        }

        public void IncreaseScore()
        {
            PositionNumber1++;
            
            if (PositionNumber1 < 10)
            {
                recNumber0CutPosition.X = texNumber.Width / 10 * PositionNumber1;
            }
            else
            {
               
                PositionNumber1 = 0;
                recNumber0CutPosition.X = texNumber.Width / 10 * PositionNumber1;
         
                PositionNumber2++;
            }

            if (PositionNumber2 > 0)
            {
                recNumber1CutPosition.X = texNumber.Width / 10 * PositionNumber2;
            }
            else if(PositionNumber1 == 0)
            {
                PositionNumber2 = 0;
                recNumber1CutPosition.X = texNumber.Width / 10 * PositionNumber2;
          
                PositionNumber3++;
            }

            if (PositionNumber3 > 0)
            {
                recNumber2CutPosition.X = texNumber.Width / 10 * PositionNumber3;
            }
            else if(PositionNumber2 == 0 && PositionNumber1 == 0)
            {
                PositionNumber3 = 0;
                recNumber2CutPosition.X = texNumber.Width / 10 * PositionNumber3;
        
            }
        }

        public void Update()
        {
            if (LiveCount == 2)
            {
                recLive0CutPositionAndDimension.X = texLive.Width / 2;
            }

            if (LiveCount == 1)
            {
                recLive1CutPositionAndDimension.X = texLive.Width / 2;
            }

            if (LiveCount == 0)
            {
                recLive2CutPositionAndDimension.X = texLive.Width / 2;
            }

           
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(texFrame,  recFramePosition0AndDimension, Color.White);
            spriteBatch.Draw(texNumber, recNumber0PositionAndDimension,  recNumber0CutPosition, Color.White);
            spriteBatch.Draw(texNumber, recNumber1PositionAndDimension, recNumber1CutPosition, Color.White);
            spriteBatch.Draw(texNumber, recNumber2PositionAndDimension, recNumber2CutPosition, Color.White);
            
            
            spriteBatch.Draw(texLive, recLive0PositionAndDimension, recLive0CutPositionAndDimension, Color.White);
            spriteBatch.Draw(texLive, recLive1PositionAndDimension, recLive1CutPositionAndDimension, Color.White);
            spriteBatch.Draw(texLive, recLive2PositionAndDimension, recLive2CutPositionAndDimension, Color.White);
        }
    }
}
